#include <stdio.h>
#include <string.h>
#include <ogcsys.h>
#include <malloc.h>

#include "fat.h"
#include "apploader.h"
#include "wdvd.h"
#include "alternatedol.h"
#include "fstfile.h"
#include "ocarina.h" /*FISHEARS*/
#include "kenobiwii.h" /*FISHEARS*/

//#define ALTDOL_PATH	"fat:/config/mighty/altdol/"

/*KENOBI! - FISHEARS*/
extern const unsigned char kenobiwii[];
extern const int kenobiwii_size;
/*KENOBI! - FISHEARS*/


/* Apploader function pointers */
typedef int   (*app_main)(void **dst, int *size, int *offset);
typedef void  (*app_init)(void (*report)(const char *fmt, ...));
typedef void *(*app_final)();
typedef void  (*app_entry)(void (**init)(void (*report)(const char *fmt, ...)), int (**main)(), void *(**final)());

/* Apploader pointers */
static u8 *appldr = (u8 *)0x81200000;


/* Constants */
#define APPLDR_OFFSET	0x2440

/* Variables */
static u32 buffer[0x20] ATTRIBUTE_ALIGN(32);


static void __noprint(const char *fmt, ...)
{
}

/* thanks WiiPower! */
bool NewSuperMarioBrosPatch(void *Address, int Size){
	if (memcmp("SMNE", (char *)0x80000000, 4) == 0){
		u8 SearchPattern[32] =  { 0x94, 0x21, 0xFF, 0xD0, 0x7C, 0x08, 0x02, 0xA6, 0x90, 0x01, 0x00, 0x34, 0x39, 0x61, 0x00, 0x30, 0x48, 0x12, 0xD7, 0x89, 0x7C, 0x7B, 0x1B, 0x78, 0x7C, 0x9C, 0x23, 0x78, 0x7C, 0xBD, 0x2B, 0x78 };
		u8 PatchData[32] =              { 0x4E, 0x80, 0x00, 0x20, 0x7C, 0x08, 0x02, 0xA6, 0x90, 0x01, 0x00, 0x34, 0x39, 0x61, 0x00, 0x30, 0x48, 0x12, 0xD7, 0x89, 0x7C, 0x7B, 0x1B, 0x78, 0x7C, 0x9C, 0x23, 0x78, 0x7C, 0xBD, 0x2B, 0x78 };

		void *Addr = Address;
		void *Addr_end = Address+Size;

		while(Addr <= Addr_end-sizeof(SearchPattern)){
			if(memcmp(Addr, SearchPattern, sizeof(SearchPattern))==0){
				memcpy(Addr,PatchData,sizeof(PatchData));
				return true;
			}
			Addr += 4;
		}
	}
	else if (memcmp("SMN", (char *)0x80000000, 3) == 0){
		u8 SearchPattern[32] =  { 0x94, 0x21, 0xFF, 0xD0, 0x7C, 0x08, 0x02, 0xA6, 0x90, 0x01, 0x00, 0x34, 0x39, 0x61, 0x00, 0x30, 0x48, 0x12, 0xD9, 0x39, 0x7C, 0x7B, 0x1B, 0x78, 0x7C, 0x9C, 0x23, 0x78, 0x7C, 0xBD, 0x2B, 0x78 };
		u8 PatchData[32] =              { 0x4E, 0x80, 0x00, 0x20, 0x7C, 0x08, 0x02, 0xA6, 0x90, 0x01, 0x00, 0x34, 0x39, 0x61, 0x00, 0x30, 0x48, 0x12, 0xD9, 0x39, 0x7C, 0x7B, 0x1B, 0x78, 0x7C, 0x9C, 0x23, 0x78, 0x7C, 0xBD, 0x2B, 0x78 };

		void *Addr = Address;
		void *Addr_end = Address+Size;

		while(Addr <= Addr_end-sizeof(SearchPattern)){
			if(memcmp(Addr, SearchPattern, sizeof(SearchPattern))==0){
				memcpy(Addr,PatchData,sizeof(PatchData));
				return true;
			}
			Addr += 4;
		}
	}
	return false;
}


s32 Apploader_Run(entry_point *entry,bool ocarina,u16 altdol)
{
	app_entry appldr_entry;
	app_init  appldr_init;
	app_main  appldr_main;
	app_final appldr_final;

	u32 appldr_len;
	s32 ret;

	/* Read apploader header */
	ret = WDVD_Read(buffer, 0x20, APPLDR_OFFSET);
	if (ret < 0)
		return ret;

	/* Calculate apploader length */
	appldr_len = buffer[5] + buffer[6];

	/* Read apploader code */
	ret = WDVD_Read(appldr, appldr_len, APPLDR_OFFSET + 0x20);
	if (ret < 0)
		return ret;

	/* Set apploader entry function */
	appldr_entry = (app_entry)buffer[4];

	/* Call apploader entry */
	appldr_entry(&appldr_init, &appldr_main, &appldr_final);

	/* Initialize apploader */
	appldr_init(__noprint);

	/*OCARINA STUFF - FISHEARS*/
	if(ocarina){
		memset((void*)0x80001800,0,kenobiwii_size);
		memcpy((void*)0x80001800,kenobiwii,kenobiwii_size);
		DCFlushRange((void*)0x80001800,kenobiwii_size);
		//hooktype = 1;
		memcpy((void*)0x80001800, (char*)0x80000000, 6);	// For WiiRD
	}
	/*OCARINA STUFF - FISHEARS*/

	for (;;) {
		void *dst = NULL;
		s32   len = 0, offset = 0;

		/* Run apploader main function */
		ret = appldr_main(&dst, &len, &offset);
		if (!ret)
			break;

		/* Read data from DVD */
		WDVD_Read(dst, len, (u64)(offset << 2));

		NewSuperMarioBrosPatch(dst,len);
		
		if(ocarina){
			/*HOOKS STUFF - FISHEARS*/
        	dogamehooks(dst,len);
			/*HOOKS STUFF - FISHEARS*/
		}
	}

	/* Set entry point from apploader */
	*entry = appldr_final();

	//Load alternate DOL
	if(altdol>0){
		FST_ENTRY *fst = (FST_ENTRY *)*(u32 *)0x80000038;
		*entry = (entry_point) Load_Dol_from_disc(fst[altdol].fileoffset);

		if (*entry == 0)
			SYS_ResetSystem(SYS_RETURNTOMENU, 0, 0);
	}

        
	return 0;
}
